package banco.cliente;

import java.sql.*;

import banco.conta.ContaExistenteException;
import banco.util.ConnectionManager;


public class BDClientes implements RepositorioClientes {

	private static BDClientes instance;
    private static Connection connection;
    private static Statement statement;
    
    public BDClientes() {
    }
    
    public synchronized static BDClientes getInstance() {
        if (instance == null) {
            instance = new BDClientes();
        }
        return instance;
    }
    
       
    public void inserir(Cliente cliente) throws SQLException, ClienteExistenteException {
        try {
        	if (existe(cliente.getCpf())) {
        		throw new ClienteExistenteException("Cliente j cadastrado: " + cliente.getCpf());
        	}
        	Statement statement = ConnectionManager.preparaStatement();
            if (cliente != null) {
                statement.executeUpdate("INSERT INTO CLIENTES VALUES ('" +
                           cliente.getCpf() + "', '" +
                           cliente.getNome() + "')");
            }
        } catch (SQLException e) {
            throw new SQLException("BDClientes => inserirCliente: " +e);
	    }
    }

	public void remover(String cpf) throws ClienteInexistenteException, SQLException {
        try{
            Statement statement = ConnectionManager.preparaStatement();
		    int resultado = statement.executeUpdate("DELETE FROM CLIENTES WHERE cpf='" + cpf + "'");
            if (resultado == 0) {
                throw new ClienteInexistenteException(cpf);
            } 
		} catch(SQLException e){
            throw new SQLException("BDClientes => removerCliente: " + e);
		} 
	}

	public Cliente procurar(String cpf) throws ClienteInexistenteException, SQLException {
   	    Cliente cliente = null;
        try {
            Statement statement = ConnectionManager.preparaStatement();
            ResultSet resultset = statement.executeQuery("SELECT * FROM CLIENTES WHERE cpf = '" + cpf + "'");
            if (resultset.next()) {
                cliente = new Cliente(resultset.getString("cpf"), resultset.getString("nome"));
            } else {
                throw new ClienteInexistenteException(cpf);
            }
        } catch (SQLException e) {
			throw new SQLException("BDClientes => procurarCliente: " + e);
		} 
		return cliente;
	}

	public void atualizar(Cliente cliente) throws ClienteInexistenteException, SQLException {
	  try {
	     Statement statement = ConnectionManager.preparaStatement();
         if (cliente != null) {
             int resultado = statement.executeUpdate("UPDATE CLIENTES SET nome = '" + cliente.getNome() +
          	                                        "' WHERE cpf = '" + cliente.getCpf() + "'");
             if (resultado == 0) {
                   throw new ClienteInexistenteException(cliente.getCpf());
             } 
         }
	  } catch (SQLException e) {
		    throw new SQLException("BDClientes => atualizarCliente: " + e);
	  }
                
	}

	public boolean existe(String cpf) throws SQLException {
   	    boolean resposta = false;
        try {
            Statement statement = ConnectionManager.preparaStatement();
            ResultSet resultset = statement.executeQuery("SELECT * FROM CLIENTES WHERE cpf = '" + cpf + "'");
            resposta = resultset.next();
			//resultset.close();
        } catch (SQLException e) {
			throw new SQLException("BDClientes => existeCliente: " + e);
		} 
		return resposta;
    }
	
	public void liberaRecursos() {
		ConnectionManager.liberaRecursos();
	}
   
}