package banco.cliente;

import java.util.HashMap;

public class ColecaoClientes implements RepositorioClientes {
	
	private HashMap clientes;
	private static ColecaoClientes instance;
	
	public ColecaoClientes() {
		clientes = new HashMap <String, Cliente>();
	}
	
	public synchronized static ColecaoClientes getInstance() {
		if (instance == null) {
			instance = new ColecaoClientes();
		} 
		return instance;
	}
     
	public boolean existe(String cpf) {
		boolean achou = false;
		if (clientes.containsKey(cpf)) {
			achou = true;
		}
		return achou;
	}
	
	public void atualizar(Cliente c) 
    throws ClienteInexistenteException {
		if (existe(c.getCpf())) {
			clientes.remove(c);
			clientes.put(c.getCpf(),c);
		} else {
			throw new ClienteInexistenteException("Cliente nao encontrado");
		}
	}
	
	public void inserir(Cliente c) throws ClienteExistenteException {
		if (!existe(c.getCpf())) {
			clientes.put(c.getCpf(),c);
		} else {
			throw new ClienteExistenteException("Cliente j cadastrado");
		}
	}
	
	public Cliente procurar(String cpf) throws ClienteInexistenteException {
		Cliente c = null;
		if (existe(cpf)) {
			c = (Cliente) clientes.get(cpf);
		} else {
			throw new ClienteInexistenteException("Cliente nao encontrado");
		}
		return c;
	}
	
	public void remover(String cpf) throws ClienteInexistenteException {
		if (existe(cpf)) {
			clientes.remove(cpf);
		} else {
			throw new ClienteInexistenteException("Cliente nao encontrado");
		}
	}
	
	public void liberaRecursos() {
    	clientes = null;
    }
	
}
