package banco.conta;
import java.util.*;
import banco.cliente.Cliente;
public class ArrayContas implements RepositorioContas {
	private Conta[]  contas;
	private int indice;
	private final static int tamCache = 100;

	public ArrayContas() {
	  indice = 0;
	  contas = new Conta[tamCache];
	}

	public void atualizar(Conta c) throws ContaInexistenteException{
	  int i = procurarIndice(c.getNumero());
	  if (i != -1) {
	    contas[i] = c;
	  } else {
	    throw new ContaInexistenteException("Conta nao encontrada");
	  }
	}
	public boolean existe(String num) {
	  boolean resp = false;

	  int i = this.procurarIndice(num);
	  if(i != -1){
		resp = true;
	  }

	  return resp;
	}
	public void inserir(Conta c) throws ContaExistenteException {
	    if (existe(c.getNumero())) {
	    	throw new ContaExistenteException("Conta j cadastrada");
	    } else {
	    	contas[indice] = c;
		    indice = indice + 1;	
	    }
	}

	public Conta procurar(String num) throws ContaInexistenteException{
	  Conta c = null;
	  if (existe(num)) {
  	    int i = this.procurarIndice(num);
	    c = contas[i];
	  } else {
	    throw new ContaInexistenteException("Conta nao encontrada");
	  }

	  return c;
	}

	private int procurarIndice(String num) {
	  int     i = 0;
	  int     ind = -1;
	  boolean achou = false;

	  while ((i < indice) && !achou) {
	    if ((contas[i].getNumero()).equals(num)) {
		  ind = i;
		  achou = true;
	    }
	    i = i + 1;
	  }
	  return ind;
	}

	public void remover(String num) throws ContaInexistenteException{
	  if (existe(num)) {
  	    int i = this.procurarIndice(num);
	    contas[i] = contas[indice - 1];
	    contas[indice - 1] = null;
	    indice = indice - 1;
	  } else {
	    throw new ContaInexistenteException("Conta nao encontrada");
	  }
	}
    
	public Collection getContasCliente(Cliente cli) throws ContaExistenteException {
		/*ArrayContas contasCliente = new ArrayContas();
		int i = 0;
		while ((i < indice)) {
		    if ((contas[i].getCliente().getCpf()).equals(cpf)) {
		      contasCliente.inserir(contas[i]);
		    }
		    i = i + 1;
		  }*/
    	return null;
    }
	
	public Conta[] getContas() {
		return this.contas;
	}

	
	public void liberaRecursos() {
		contas = null;
	}

}
