package banco.conta;

import java.sql.SQLException;

import banco.cliente.Cliente;
import banco.cliente.ClienteInexistenteException;
import java.util.Collection;

public interface RepositorioContas {

	public void inserir(Conta conta) throws ContaExistenteException, SQLException;

	public void remover(String numero) throws ContaInexistenteException, SQLException;

	public Conta procurar(String numero) throws ContaInexistenteException, SQLException;

	public void atualizar(Conta conta) throws ContaInexistenteException, SQLException;
	
	public boolean existe(String numero) throws SQLException;
		
	public Collection getContasCliente(Cliente cli) throws SQLException, ClienteInexistenteException, ContaExistenteException;
	
	public void liberaRecursos();
	
}