package banco.web;

import java.io.IOException;
import java.sql.SQLException;
import java.io.PrintWriter;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import banco.fachada.Fachada;
import banco.cliente.Cliente;
import banco.cliente.ClienteExistenteException;
import banco.cliente.ClienteInexistenteException;
import java.util.HashMap;
import java.util.Collection;;

public class CadastroClientes extends HttpServlet {

	public CadastroClientes() {
		super();
	}

	public void destroy() {
		super.destroy(); 
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		this.doPost(request, response);		
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		
		//Pega a instncia da fachada 
		Fachada fachada = Fachada.obterInstancia();
				
		//Pegar parmetros do cliente
		String cpfCliente = request.getParameter("cpfClienteJsp");
		String nomeCliente = request.getParameter("nomeClienteJsp");
		String mensagem = "";		
		try { 
			if(request.getParameter("btnNovo")!= null){
				Cliente cli = new Cliente(cpfCliente,nomeCliente);
				fachada.inserirCliente(cli);
				mensagem = "Cliente cadastrado com sucesso";
			} else if(request.getParameter("btnProcurar")!= null){
				Cliente cli = fachada.procurarCliente(cpfCliente);
				request.setAttribute("cliente", cli);   
				RequestDispatcher dispatcher = getServletContext().
			                                   getRequestDispatcher("/jsp/clientesEdit.jsp");
		    	dispatcher.forward(request, response);
			} else if(request.getParameter("btnAtualizar")!= null ||
					  request.getParameter("btnSalvar")!= null){
				Cliente cli = new Cliente(cpfCliente,nomeCliente);
				fachada.atualizarCliente(cli);
				mensagem = "Cliente alterado com sucesso";
			} else if(request.getParameter("btnRemover")!= null){
				fachada.removerCliente(cpfCliente);
				mensagem = "Cliente removido com sucesso";
			} else if(request.getParameter("btnContas")!= null){
				Cliente cli = fachada.procurarCliente(cpfCliente);
				request.setAttribute("cliente", cli); 
				Collection contas = fachada.getContasCliente(cli.getCpf());
				request.setAttribute("contas",contas);
				RequestDispatcher dispatcher = getServletContext().
			                                   getRequestDispatcher("/jsp/contasList.jsp");
		    	dispatcher.forward(request, response);
				
			} 
		} catch (ClienteInexistenteException e) {
			mensagem = e.getMessage();
			e.printStackTrace();
		} catch (ClienteExistenteException e) {
			mensagem = e.getMessage();
			e.printStackTrace();
		} catch (SQLException e) {
			mensagem = e.getMessage();
			e.printStackTrace();
		} catch (Exception e) {
			mensagem = e.getMessage();
			e.printStackTrace();
		}
		
		PrintWriter out = response.getWriter();
	    out.println("<head><title>MBank</title></head>");
	    out.println("<body>");
	    out.println("<center><h1>" + mensagem + "</h1><center>");
	    out.println("<center><p><b><a href=\"\">Voltar</a></b></center>");
	    out.println("</body>");
	    out.close();
	}

	public void init() throws ServletException {
		// Put your code here
	}

}

