package banco.web;

import java.io.IOException;
import java.sql.SQLException;
import java.io.PrintWriter;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import banco.fachada.Fachada;
import banco.conta.Conta;
import banco.conta.Poupanca;
import banco.conta.ContaBonificada;
import banco.conta.ContaInexistenteException;
import banco.conta.ContaExistenteException;
import banco.conta.SaldoInsuficienteException;
import banco.cliente.Cliente;
import banco.cliente.ClienteInexistenteException;



public class CadastroContas extends HttpServlet {

	public CadastroContas() {
		super();
	}

	public void destroy() {
		super.destroy(); 
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		this.doPost(request,response);	
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
				
		//Pega a instncia da fachada 
		Fachada fachada = Fachada.obterInstancia();
		
		//Pegar parmetros da conta
		String numeroConta   = request.getParameter("numeroContaJsp");
		String saldoContaStr = request.getParameter("saldoContaJsp");
		double saldo = 0;
		if (saldoContaStr != null && !saldoContaStr.equals("")) {
			saldo = Double.parseDouble(saldoContaStr);
		}
		String valorStr = request.getParameter("valorJsp");
		double valor = 0;
		if (valorStr != null && !valorStr.equals("")) {
			valor = Double.parseDouble(valorStr);
		}
		String mensagem = "";		
		try { 
			String cpfCliente    = request.getParameter("cpfClienteJsp");
			if(request.getParameter("btnNova")!= null){
				String tipo = request.getParameter("tipoContaJsp");
				Cliente cli = fachada.procurarCliente(cpfCliente);
				Conta c = null;
				if (tipo.equals("cc")) 
					c = new Conta(numeroConta,saldo,cli);
				else
					if (tipo.equals("p"))
					  c = new Poupanca(numeroConta,saldo,cli);	
					else
					  c = new ContaBonificada(numeroConta,saldo,cli);
				fachada.inserirConta(c);
				mensagem = "Conta cadastrada com sucesso";
			} else if(request.getParameter("btnProcurar")!= null){
				Cliente cli = fachada.procurarCliente(cpfCliente);
				Conta c = fachada.procurarConta(numeroConta);
				c.setCliente(cli);
				request.setAttribute("conta", c);   
				RequestDispatcher dispatcher = getServletContext().
			                                   getRequestDispatcher("/jsp/contasEdit.jsp");
		    	dispatcher.forward(request, response);
			} else if(request.getParameter("btnRemover")!= null){
				fachada.removerConta(numeroConta);
				mensagem = "Conta removida com sucesso";
			} else if(request.getParameter("btnDebitar")!= null){
				fachada.debitar(numeroConta, valor);
				mensagem = "Conta debitada com sucesso";
			} else if(request.getParameter("btnCreditar")!= null){
				fachada.creditar(numeroConta, valor);
				mensagem = "Conta creditada com sucesso";
			} 
		} catch (ClienteInexistenteException e) {
			mensagem = e.getMessage();
			e.printStackTrace();
		} catch (ContaExistenteException e) {
			mensagem = e.getMessage();
			e.printStackTrace();
		} catch (ContaInexistenteException e) {
			mensagem = e.getMessage();
			e.printStackTrace();
		} catch (SaldoInsuficienteException e) {
			mensagem = e.getMessage();
			e.printStackTrace();
		} catch (SQLException e) {
			mensagem = e.getMessage();
			e.printStackTrace();
		}
		
		PrintWriter out = response.getWriter();
	    out.println("<head><title>MBank</title></head>");
	    out.println("<body>");
	    out.println("<center><h1>" + mensagem + "</h1><center>");
	    out.println("<center><p><b><a href=\"\">Voltar</a></b></center>");
	    out.println("</body>");
	    out.close();
	}
	
	public void init() throws ServletException {
		// Put your code here
	}

}

